"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var encrypt_1 = require("../../shared/encrypt");
var moment = require("moment");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function AccountSubAccountVCCDetailTransactionMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.AccountSubAccountVCCDetailTransactionMSSql = AccountSubAccountVCCDetailTransactionMSSql;
function AccountSubAccountVCCBatchDetailCreate(platformHash, installationId, accountId, subAccountId, vcc, channel, durationTime, type, systemService, processId, templateId, interactionId, interactionSection, interactionPart) {
    return new sql.Request(sqlConn)
        .input('PlatformHash', sql.VarChar(100), platformHash)
        .input('InstallationId', sql.VarChar(50), installationId)
        .input('AccountId', sql.VarChar(50), accountId)
        .input('SubAccountId', sql.VarChar(50), subAccountId)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Channel', sql.VarChar(50), channel)
        .input('DurationTime', sql.Int, durationTime)
        .input('Type', sql.VarChar(50), type)
        .input('SystemService', sql.VarChar(50), systemService)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('InteractionId', sql.VarChar(50), interactionId)
        .input('InteractionSection', sql.Int, interactionSection)
        .input('InteractionPart', sql.Int, interactionPart)
        .execute('AccountSubAccountVCCBatchDetailCreate')
        .then(function (recordsets) {
        logger.info('[AccountSubAccountVCCDetailTransactionMSSql.mssql::AccountSubAccountVCCBatchDetailCreate] Result: ', recordsets);
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.AccountSubAccountVCCBatchDetailCreate = AccountSubAccountVCCBatchDetailCreate;
function AccountSubAccountVCCBatchDetailClose(platformHash, installationId, accountId, subAccountId, vcc, type, systemService, processId, templateId, interactionId, interactionSection, interactionPart, validDurationTime, isValid) {
    return new sql.Request(sqlConn)
        .input('PlatformHash', sql.VarChar(100), platformHash)
        .input('InstallationId', sql.VarChar(50), installationId)
        .input('AccountId', sql.VarChar(50), accountId)
        .input('SubAccountId', sql.VarChar(50), subAccountId)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Type', sql.VarChar(50), type)
        .input('SystemService', sql.VarChar(50), systemService)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('InteractionId', sql.VarChar(50), interactionId)
        .input('InteractionSection', sql.Int, interactionSection)
        .input('InteractionPart', sql.Int, interactionPart)
        .input('ValidDurationTime', sql.Int, validDurationTime)
        .input('IsValid', sql.Bit, isValid)
        .execute('AccountSubAccountVCCBatchDetailClose')
        .then(function (recordsets) {
        logger.info('[AccountSubAccountVCCDetailTransactionMSSql.mssql::AccountSubAccountVCCBatchDetailClose] Result: ', recordsets);
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.AccountSubAccountVCCBatchDetailClose = AccountSubAccountVCCBatchDetailClose;
function AccountSubAccountVCCBulkNewBatchDetail(platformHash, installationId, accountId, subAccountId, data) {
    var table = new sql.Table('#AccountSubAccountVCCBulkNewBatchDetailTemp');
    table.create = true;
    table.columns.add('PlatformHash', sql.VarChar(100), { nullable: true });
    table.columns.add('InstallationId', sql.VarChar(50), { nullable: true });
    table.columns.add('AccountId', sql.VarChar(50), { nullable: true });
    table.columns.add('SubAccountId', sql.VarChar(50), { nullable: true });
    table.columns.add('VCC', sql.VarChar(50), { nullable: true });
    table.columns.add('BatchTypeName', sql.VarChar(50), { nullable: true });
    table.columns.add('BatchTypeId', sql.VarChar(50), { nullable: true });
    table.columns.add('SystemService', sql.VarChar(50), { nullable: true });
    table.columns.add('ProcessId', sql.VarChar(100), { nullable: true });
    table.columns.add('EntityId', sql.VarChar(500), { nullable: true });
    table.columns.add('StartDate', sql.DateTime, { nullable: true });
    table.columns.add('EndDate', sql.DateTime, { nullable: true });
    table.columns.add('DurationTime', sql.Int, { nullable: true });
    table.columns.add('Channel', sql.VarChar(50), { nullable: true });
    table.columns.add('TotalValidRequest', sql.Int, { nullable: true });
    data.map(function (d) {
        var decryptedData = encrypt_1.InconcertDecrypt(d.split('::')[0]);
        logger.info('[AccountSubAccountVCCDetailedTransaction::AccountSubAccountVCCBulkNewBatchDetail::' + platformHash + '] Decrypted data: ' + decryptedData);
        var arrDecryptedData = decryptedData.split('::');
        var platformHashField = platformHash;
        var installationIdField = installationId ? installationId : null;
        var accountIdField = accountId ? accountId : null;
        var subAccountIdField = subAccountId ? subAccountId : null;
        var vccField = arrDecryptedData[1] ? arrDecryptedData[1] : null;
        var batchTypeNameField = arrDecryptedData[2] ? arrDecryptedData[2] : null;
        var batchTypeIdField = arrDecryptedData[3] ? arrDecryptedData[3] : null;
        var systemServiceField = arrDecryptedData[4] ? arrDecryptedData[4] : null;
        var processIdField = arrDecryptedData[5] ? arrDecryptedData[5] : null;
        var entityIdField = arrDecryptedData[6] ? arrDecryptedData[6] : null;
        var startDateField = arrDecryptedData[8] && arrDecryptedData[4] === 'TRANSCRIPTION' ? moment(arrDecryptedData[8]).toDate() : null;
        var endDateField = arrDecryptedData[9] && arrDecryptedData[4] === 'TRANSCRIPTION' ? moment(arrDecryptedData[9]).toDate() : null;
        var durationField = arrDecryptedData[10] && arrDecryptedData[4] === 'TRANSCRIPTION' ? (arrDecryptedData[10] === 'null' ? 0 : null) : null;
        var channelField = arrDecryptedData[7] && arrDecryptedData[4] === 'TRANSCRIPTION' ? arrDecryptedData[7] : null;
        var totalValidRequestField = arrDecryptedData[7] && (arrDecryptedData[4] === 'COGNITIVE_ANALYSIS' || arrDecryptedData[4] === 'SEMANTIC_ANALYSIS') ? arrDecryptedData[7] : null;
        table.rows.add(platformHashField, installationIdField, accountIdField, subAccountIdField, vccField, batchTypeNameField, batchTypeIdField, systemServiceField, processIdField, entityIdField, startDateField, endDateField, durationField, channelField, totalValidRequestField);
        logger.info('[AccountSubAccountVCCDetailedTransaction::AccountSubAccountVCCBulkNewBatchDetail::' + platformHash + '] Added to temporaryTable: ', platformHashField, installationIdField, accountIdField, subAccountIdField, vccField, batchTypeNameField, batchTypeIdField, systemServiceField, processIdField, entityIdField, startDateField, endDateField, durationField, channelField, totalValidRequestField);
    });
    return AccountSubAccountVCCTransactionBatchDetail(table, 'new');
}
exports.AccountSubAccountVCCBulkNewBatchDetail = AccountSubAccountVCCBulkNewBatchDetail;
function AccountSubAccountVCCBulkUpdateBatchDetail(platformHash, installationId, accountId, subAccountId, data) {
    var table = new sql.Table('#AccountSubAccountVCCBulkUpdateBatchDetailTemp');
    table.create = true;
    table.columns.add('PlatformHash', sql.VarChar(100), { nullable: true });
    table.columns.add('InstallationId', sql.VarChar(50), { nullable: true });
    table.columns.add('AccountId', sql.VarChar(50), { nullable: true });
    table.columns.add('SubAccountId', sql.VarChar(50), { nullable: true });
    table.columns.add('VCC', sql.VarChar(50), { nullable: true });
    table.columns.add('BatchTypeName', sql.VarChar(50), { nullable: true });
    table.columns.add('BatchTypeId', sql.VarChar(50), { nullable: true });
    table.columns.add('SystemService', sql.VarChar(50), { nullable: true });
    table.columns.add('ProcessId', sql.VarChar(100), { nullable: true });
    table.columns.add('EntityId', sql.VarChar(500), { nullable: true });
    table.columns.add('FieldToUpdate', sql.VarChar(50), { nullable: true });
    table.columns.add('ValueToUpdate', sql.VarChar(250), { nullable: true });
    data.map(function (d) {
        var decryptedData = encrypt_1.InconcertDecrypt(d.split('::')[0]);
        logger.info('[AccountSubAccountVCCDetailedTransaction::AccountSubAccountVCCBulkUpdateBatchDetail] Decrypted data: ' + decryptedData);
        var arrDecryptedData = decryptedData.split('::');
        table.rows.add(platformHash, installationId ? installationId : null, accountId ? accountId : null, subAccountId ? subAccountId : null, arrDecryptedData[1] ? arrDecryptedData[1] : null, arrDecryptedData[2] ? arrDecryptedData[2] : null, arrDecryptedData[3] ? arrDecryptedData[3] : null, arrDecryptedData[4] ? arrDecryptedData[4] : null, arrDecryptedData[5] ? arrDecryptedData[5] : null, arrDecryptedData[6] ? arrDecryptedData[6] : null, arrDecryptedData[7] ? arrDecryptedData[7] : null, arrDecryptedData[8] ? arrDecryptedData[8] : null);
    });
    return AccountSubAccountVCCTransactionBatchDetail(table, 'update');
}
exports.AccountSubAccountVCCBulkUpdateBatchDetail = AccountSubAccountVCCBulkUpdateBatchDetail;
function AccountSubAccountVCCBulkCloseBatchDetail(platformHash, installationId, accountId, subAccountId, data) {
    var table = new sql.Table('#AccountSubAccountVCCBulkCloseBatchDetailTemp');
    table.create = true;
    table.columns.add('PlatformHash', sql.VarChar(100), { nullable: true });
    table.columns.add('InstallationId', sql.VarChar(50), { nullable: true });
    table.columns.add('AccountId', sql.VarChar(50), { nullable: true });
    table.columns.add('SubAccountId', sql.VarChar(50), { nullable: true });
    table.columns.add('VCC', sql.VarChar(50), { nullable: true });
    table.columns.add('BatchTypeName', sql.VarChar(50), { nullable: true });
    table.columns.add('BatchTypeId', sql.VarChar(50), { nullable: true });
    table.columns.add('SystemService', sql.VarChar(50), { nullable: true });
    table.columns.add('ProcessId', sql.VarChar(100), { nullable: true });
    table.columns.add('EntityId', sql.VarChar(500), { nullable: true });
    table.columns.add('ResultCode', sql.Bit, { nullable: true });
    table.columns.add('ResultDescription', sql.VarChar(50), { nullable: true });
    data.map(function (d) {
        var decryptedData = encrypt_1.InconcertDecrypt(d.split('::')[0]);
        logger.info('[AccountSubAccountVCCDetailedTransaction::AccountSubAccountVCCBulkCloseBatchDetail] Decrypted data: ' + decryptedData);
        var arrDecryptedData = decryptedData.split('::');
        table.rows.add(platformHash, installationId ? installationId : null, accountId ? accountId : null, subAccountId ? subAccountId : null, arrDecryptedData[1] ? arrDecryptedData[1] : null, arrDecryptedData[2] ? arrDecryptedData[2] : null, arrDecryptedData[3] ? arrDecryptedData[3] : null, arrDecryptedData[4] ? arrDecryptedData[4] : null, arrDecryptedData[5] ? arrDecryptedData[5] : null, arrDecryptedData[6] ? arrDecryptedData[6] : null, arrDecryptedData[7] === '1' ? true : false, arrDecryptedData[8] ? arrDecryptedData[8] : null);
    });
    return AccountSubAccountVCCTransactionBatchDetail(table, 'close');
}
exports.AccountSubAccountVCCBulkCloseBatchDetail = AccountSubAccountVCCBulkCloseBatchDetail;
function AccountSubAccountVCCTransactionBatchDetail(temporaryTable, operation) {
    var transaction = new sql.Transaction(sqlConn);
    var request;
    return transaction.begin()
        .then(function (result) {
        logger.info('[AccountSubAccountVCCDetailedTransaction::AccountSubAccountVCCTransactionBatchDetail] Creating request');
        return new sql.Request(transaction);
    })
        .then(function (result) {
        request = result;
        return request.bulk(temporaryTable)
            .then(function (rowCount) {
            logger.info('[AccountSubAccountVCCDetailedTransaction::AccountSubAccountVCCTransactionBatchDetail] Inserted ' + rowCount + ' records to temporary Table');
            return true;
        })
            .catch(function (err) {
            logger.error('[AccountSubAccountVCCDetailedTransaction::AccountSubAccountVCCTransactionBatchDetail] Al realizar el bulk: ' + err.message + ' en la tabla temporal ');
            throw err;
        });
    })
        .then(function (result) {
        var myBulkStoredProcedure = '';
        switch (operation) {
            case 'new':
                myBulkStoredProcedure = 'AccountSubAccountVCCBulkNewBatchDetail';
                break;
            case 'update':
                myBulkStoredProcedure = 'AccountSubAccountVCCBulkUpdateBatchDetail';
                break;
            case 'close':
                myBulkStoredProcedure = 'AccountSubAccountVCCBulkCloseBatchDetail';
                break;
        }
        if (myBulkStoredProcedure === '')
            throw 'SERVER_ERROR_UNKNOWN_OPERATION';
        return request.execute(myBulkStoredProcedure)
            .then(function (recordset) {
            logger.info('[AccountSubAccountVCCDetailedTransaction::AccountSubAccountVCCTransactionBatchDetail] Ejecucion Correcta ' + myBulkStoredProcedure);
            return Promise.resolve(true);
        })
            .catch(function (err) {
            logger.error('[AccountSubAccountVCCDetailedTransaction::AccountSubAccountVCCTransactionBatchDetail] Al ejecutar el procedure ' + myBulkStoredProcedure + ': ' + err.message);
            return Promise.reject(err);
        });
    })
        .then(function (result) {
        logger.info('[AccountSubAccountVCCDetailedTransaction::AccountSubAccountVCCTransactionBatchDetail] Saving transaction');
        return transaction.commit();
    })
        .then(function (result) {
        logger.info('[AccountSubAccountVCCDetailedTransaction::AccountSubAccountVCCTransactionBatchDetail] Saved transaction: ' + result);
        return Promise.resolve(true);
    })
        .catch(function (err) {
        logger.error('[AccountSubAccountVCCDetailedTransaction::AccountSubAccountVCCTransactionBatchDetail] Parsing error: ' + err.message);
        transaction.rollback();
        return Promise.reject(err);
    });
}
exports.AccountSubAccountVCCTransactionBatchDetail = AccountSubAccountVCCTransactionBatchDetail;
